// Music 250a 2019
// Additive synthesis 

import("stdfaust.lib");

freq = hslider("freq",440,50,1000,0.01);
gain = hslider("gain",0.5,0,1,0.01);
gate = button("gate");

envelope = en.adsr(attack,decay,sustainGain,release,gate)*gain
with{
  attack = 0.01;
  decay = 0.01;
  sustainGain = 0.8;
  release = 0.01;
};

organ(f) = os.osc(f)*0.5 + os.osc(f*2)*0.25 + os.osc(f*3)*0.125;
// could be substituted with something like:
//organ(f) = sum(i,3,os.osc(f*(i+1))*(1/(i+2)));

process = organ(freq)*envelope*0.5 <: _,_;

effect = dm.zita_light;
