// Music 250a 2019
// Simple waveshape synth

import("stdfaust.lib");

// Parameters
freq = hslider("freq",440,50,1000,0.01);
gain = hslider("gain",1,0,1,0.01);
gate = button("gate");

envelope = en.adsr(attack,decay,sustainGain,release,gate)*gain
with{
  attack = 0.01;
  decay = 0.01;
  sustainGain = 0.8;
  release = 0.01;
};

// swap os.sawtooth for os.osc, os.square, os.imptrain, or os.triangle
synth = os.imptrain(freq)*envelope;

process = synth <: _,_;

effect = dm.zita_light;
